/*
 * Road Dog wifi sniffer - Art 2007!
 */

#include <pspkernel.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <pspgu.h>
#include <pspgum.h>
#include <pspdisplay.h>
#include <time.h>     //only needed for the blinking effect
#include <pspsdk.h> // wlan sample includes
#include <stdlib.h>
#include <unistd.h>
#include <pspnet.h>
#include <pspwlan.h>
#include <pspctrl.h>
#include <pspdebug.h>
#include "../../intraFont.h"

#define printf pspDebugScreenPrintf
#define MODULE_NAME "Road_Dog"

PSP_MODULE_INFO(MODULE_NAME, 0x1000, 1, 1);
PSP_MAIN_THREAD_ATTR(0);

float y = 56;

int multi;

	// Colors
	enum colors {
		RED =	0xFF0000FF,
		GREEN =	0xFF00FF00,
		BLUE =	0xFFFF0000,
		WHITE =	0xFFFFFFFF,
		LITEGRAY = 0xFFBFBFBF,
		GRAY =  0xFF7F7F7F,
		DARKGRAY = 0xFF3F3F3F,		
		BLACK = 0xFF000000
	};

static int running = 1;
static unsigned int __attribute__((aligned(16))) list[262144];
    intraFont* ltn[16];
/* Init the scan */
int sceNet_lib_5216CBF5(const char *name);
/* Do the scan */
int sceNet_lib_7BA3ED91(const char *name, void *type, u32 *size, void *buf, u32 *unk);
/* Terminate the scan */
int sceNet_lib_D2422E4D(const char *name);

#define InitScan sceNet_lib_5216CBF5
#define ScanAPs  sceNet_lib_7BA3ED91
#define TermScan sceNet_lib_D2422E4D

unsigned char scan_data[0xA80];
char buffer[55];

/* Returned data */
struct ScanData
{
	struct ScanHead *pNext; 
	unsigned char bssid[6]; 
	char channel; 
	unsigned char namesize; 
	char name[32]; 
	unsigned int bsstype; 
	unsigned int beaconperiod; 
	unsigned int dtimperiod; 
	unsigned int timestamp; 
	unsigned int localtime; 
	unsigned short atim; 
	unsigned short capabilities; 
	unsigned char  rate[8]; 
	unsigned short rssi; 
	unsigned char  sizepad[6]; 
} __attribute__((packed));

/* Capability flags */
const char *caps[8] = {
	"ESS, ",
	"IBSS, ",
	"CF Pollable, ",
	"CF Pollreq,  ",
	"Privacy (WEP), ",
	"Short Preamble, ",
	"PBCC, ",
	"Channel Agility, "
};

/* Print the scan summary data to stdout */
void print_apsum(struct ScanData *pData)
{
	char name[33];
	strncpy(name, pData->name, 32);
	name[32] = 0;

if (multi == 1) {goto skipinit;}

		sceGuStart(GU_DIRECT, list);
		sceGumMatrixMode(GU_PROJECTION);
		sceGumLoadIdentity();
		sceGumPerspective( 75.0f, 16.0f/9.0f, 0.5f, 1000.0f);
        	sceGumMatrixMode(GU_VIEW);
		sceGumLoadIdentity();
		sceGumMatrixMode(GU_MODEL);
		sceGumLoadIdentity();
		sceGuClearColor(BLACK);
		sceGuClearDepth(0);
		sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);

	intraFontSetStyle(ltn[4], 1.0f,WHITE,BLACK,INTRAFONT_ALIGN_CENTER);
	intraFontPrint(ltn[4], 240, 26, "Road Dog - Art 2007");
        
skipinit:

	intraFontSetStyle(ltn[4], 1.0f,WHITE,BLACK,INTRAFONT_ALIGN_LEFT);
	sprintf(buffer, "SSID: %s",name);
	intraFontPrint(ltn[0], 10, y, buffer);

	if (pData->capabilities & (1 << 4)) {
        intraFontSetStyle(ltn[4], 1.0f,RED,BLACK,0);
	intraFontPrint(ltn[4], 270, y, "SECURE");
	} else {
        intraFontSetStyle(ltn[4], 1.0f,GREEN,BLACK,0);
	intraFontPrint(ltn[4], 270, y, " OPEN ");
	}

if (pData->rssi == 100) {

	intraFontSetStyle(ltn[4], 1.0f,WHITE,BLACK,INTRAFONT_ALIGN_LEFT);
	sprintf(buffer, " SIG: %d%%", pData->rssi);
	intraFontPrint(ltn[0], 360, y, buffer);
} else {
	intraFontSetStyle(ltn[4], 1.0f,WHITE,BLACK,INTRAFONT_ALIGN_LEFT);
	sprintf(buffer, " SIG: %d%%  ", pData->rssi);
	intraFontPrint(ltn[0], 360, y, buffer);
}
}

struct ScanData *do_scan(int *count){

	unsigned char type[0x4C];
	u32 size, unk;
	int i;
	int ret;

	if((ret = InitScan("wlan")) >= 0) {
		memset(type, 0, sizeof(type));
		/* Set the channels we want to scan */
		for(i = 1; i < 0xF; i++)
		{
			type[0x9+i] = i;
		}
		type[0x3C] = 1;
		*((u32*) (type + 0x44)) = 1;    //6/* Minimum strength */
		*((u32*) (type + 0x48)) = 100;  /* Maximum strength */
		size = sizeof(scan_data);
		unk  = 0;
		memset(scan_data, 0, sizeof(scan_data));
		ret = ScanAPs("wlan", type, &size, scan_data, &unk);
		if(ret < 0)
		{
		} else {
			*count = size / sizeof(struct ScanData);
			return (struct ScanData *) scan_data;
		}
	}

	TermScan("wlan");
	return NULL;
}

int exit_callback(int arg1, int arg2, void *common) {
	running = 0;
	sceWlanDevDetach();
	sceNetTerm();
	sceKernelExitGame();
	return 0;
}

int CallbackThread(SceSize args, void *argp) {
	int cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);
	sceKernelSleepThreadCB();
	return 0;
}

int SetupCallbacks(void) {
	int thid = sceKernelCreateThread("CallbackThread", CallbackThread, 0x11, 0xFA0, PSP_THREAD_ATTR_USER, 0);
	if (thid >= 0) sceKernelStartThread(thid, 0, 0);
	return thid;
}

void start_ui(struct ScanData *pScan, int count)
{

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
		
			int x;
			for (x=0;x<count;x++)
			{
				print_apsum(&pScan[x]);
				y = y + 30;
				multi = 1; // 
			}

		multi = 0; // 

		sceGuFinish();
		sceGuSync(0,0);
		sceDisplayWaitVblankStart();
		sceGuSwapBuffers();

		y = 56;

}

#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)

int main() {
	pspDebugScreenInit();
	pspDebugScreenSetTextColor(0x00EFDDCA);
	pspDebugScreenSetBackColor(0x00000000);
	SetupCallbacks();

    pspDebugScreenPrintf("intraFont 0.2 - 2007 by BenHur");

    intraFontInit();
    char file[40];
    int i;
    for (i = 0; i < 16; i++) {
        sprintf(file, "flash0:/font/ltn%d.pgf", i); 
        ltn[i] = intraFontLoad(file,0);                         //<- this is where the actual loading happens
    }
  
	sceGuInit();
	sceGuStart(GU_DIRECT, list);

	sceGuDrawBuffer(GU_PSM_8888, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x88000, BUF_WIDTH);
	sceGuDepthBuffer((void*)0x110000, BUF_WIDTH);
 
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT);
	sceGuDepthRange(65535, 0);
	sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST);
	sceGuDepthFunc(GU_GEQUAL);
	sceGuEnable(GU_DEPTH_TEST);
	sceGuFrontFace(GU_CW);
	sceGuShadeModel(GU_SMOOTH);
	sceGuEnable(GU_CULL_FACE);
	sceGuEnable(GU_CLIP_PLANES);
	sceGuEnable(GU_BLEND);
	sceGuBlendFunc(GU_ADD, GU_SRC_ALPHA, GU_ONE_MINUS_SRC_ALPHA, 0, 0);
	sceGuFinish();
	sceGuSync(0,0);
 
	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);

	pspSdkLoadInetModules();

	while(running) 	{

	int ret;
	struct ScanData *pScan = NULL;
	int count;

	ret = sceNetInit(0x20000, 0x20, 0x1000, 0x20, 0x1000);

	ret = -1;
	while(ret < 0){
		ret = sceWlanDevAttach();
		if(ret == 0x80410D0E){sceKernelDelayThread(1000000);}
	}


	while(1){
		pScan = do_scan(&count);
		start_ui(pScan, count);
		y = 56;
	}

}}
